#pragma once


#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

#include "RTTI.h"

#include "SList.h"

#include "HashMap.h"
#include "Scope.h"
#include "Vector.h"
#include "Attributed.h"
#include "IXmlParseHelper.h"

#include "expat.h"

#include "ActionList.h"

class ActionDestroyAction : public ActionList
{
	public:
		RTTI_DECLARATIONS(ActionDestroyAction, ActionList)

		//! Constructor
		/*!
			a basic constructor
		*/
		ActionDestroyAction();

		//! Deconstructor
		/*!
			a basic virtual deconstructor
		*/
		virtual ~ActionDestroyAction();

		//! Process
		/*!
			Processes this action
			\param - a pointer to the current world state
		*/
		virtual void Process(WorldState * currentWorldState);

	protected:

		//! SetupAction
		/*!

			\param - the slist of attributes to parse through
		*/
		virtual bool SetupAction(SList< pair<std::string, std::string> > * attributes);

	private:
		std::string mNameOfActionToDestroy;
		Action * mActionToDestroy;
		unsigned int mIndex;

};

//Macro
ActionFactory(ActionDestroyAction);