#pragma once

#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

//Foundation
#include "SList.h"

//Architecture
#include "RTTI.h"
#include "Datum.h"
#include "Scope.h"

//Action
#include "Action.h"
#include "ActionList.h"

//Event
#include "Event.h"
#include "EventMessageAttributed.h"

//Forward Delcarations
class EventPublisher;



class ActionEvent : public Action
{
	public:
		RTTI_DECLARATIONS(ActionEvent, Action)

		//! Constructor
		/*!
			a basic constructor
		*/
		ActionEvent();

		//! Deconstructor
		/*!
			a virtual deconstructor
		*/
		virtual ~ActionEvent();

		//! Process
		/*!
			Processes this action
			\param - a pointer to the current world state
		*/
		virtual void Process(WorldState * currentWorldState);

		//! SetupAction
		/*!
			\param - the slist of attributes to parse through
		*/
		virtual bool SetupAction(SList< pair<std::string, std::string> > * attributes);

	protected:

	private:
		std::string mSubtype;
		float mDelay;
		int mRecurring;
		bool mHasBeenProcessed;
};

//Macro
ActionFactory(ActionEvent);

