#pragma once

#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

#include "RTTI.h"

#include "SList.h"

#include "HashMap.h"
#include "Scope.h"
#include "Vector.h"
#include "Attributed.h"
#include "IXmlParseHelper.h"

#include "expat.h"

#include "ActionList.h"

class ActionPrint : public Action
{
	public:
		RTTI_DECLARATIONS(ActionPrint, Action)

		//! Constructor
		/*!
			a basic constructor
		*/
		ActionPrint();

		//! Deconstructor
		/*!
			a basic virtual deconstructor
		*/
		virtual ~ActionPrint();

		//! Process
		/*!
			Processes this action
			\param - a pointer to the current world state
		*/
		virtual void Process(WorldState * currentWorldState);

	protected:

		//! SetupAction
		/*!

			\param - the slist of attributes to parse through
		*/
		virtual bool SetupAction(SList< pair<std::string, std::string> > * attributes);

		//! LinkActionParameters
		/*!
			Links an action's parameters names to the actual paramaters.  This is done so that an action's parameters can be declared below it in xml scripting
			\return - if the link was successful or not
		*/
		virtual bool LinkActionParameters();

	private:
		std::string mNameOfDatumToPrint;
		Datum * mDatumToPrint;
		unsigned int mIndex;
};

//Macro
ActionFactory(ActionPrint);

