#pragma once

#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

//Foundation
#include "SList.h"

//Architecture
#include "RTTI.h"
#include "Datum.h"
#include "Scope.h"
#include "Attributed.h"

//World
#include "World.h"

//Action
#include "ActionList.h"

//Event
#include "IEventSubscriber.h"

//Forward Delcarations
class EventPublisher;

class EventMessageAttributed : public Attributed
{
	public:
		RTTI_DECLARATIONS(EventMessageAttributed, Attributed)

		//! Constructor
		/*!
			a basic constructor
		*/
		EventMessageAttributed();

		//! Deconstructor
		/*!
			a virtual deconstructor
		*/
		virtual ~EventMessageAttributed();

		//! GetSubtype
		/*!
			returns this subtype
			\return - the subtype
		*/
		std::string GetSubtype();

		//! SetSubtype
		/*!
			Sets the subtype
			\param - the new subtype
		*/
		void SetSubtype(std::string newSubtype);

		//! GetWorld
		/*!
			Gets the world
			\return - a pointer to the world
		*/
		World* GetWorld();

		//! SetWorld
		/*!
			Sets the world
			\param - the new world
		*/
		void SetWorld(World* newWorld);

	protected:
		World * mWorld;
		std::string mSubtype;
	private:
		
};




