#pragma once


#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

//Foundation
#include "SList.h"

//Architecture
#include "RTTI.h"
#include "Datum.h"
#include "Scope.h"

//Event
#include "Event.h"
#include "EventPublisher.h"


class EventQueue
{
	public:

		//! Enqueue
		/*!
			shall enque an event
			\param - the event to enqueue
			\param - the current time
			\param - the delay
		*/
		void Enqueue(EventPublisher * newEventPublisher, double currentTime, double delay = 0.0f);

		//! Publish
		/*!
			shall publish events that are expired
			\param - the current time
		*/
		void Publish(const double currentTime);

		//! Clear
		/*!
			shall clear the event queue
		*/
		void Clear();

	protected:

	private:
		SList<EventPublisher*> mEvents;

		double mCurrentTime;
};
