#pragma once

#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

//Foundation
#include "SList.h"

//Architecture
#include "RTTI.h"
#include "Datum.h"
#include "Scope.h"

//Action
#include "ActionList.h"

//Event
#include "IEventSubscriber.h"

//Forward Delcarations
class EventPublisher;

class Reaction : public ActionList, public IEventSubscriber
{
	public:
		RTTI_DECLARATIONS(Reaction, ActionList)


		//! Constructor
		/*!
			a basic constructor
		*/
		Reaction();

		//! Deconstructor
		/*!
			a virtual deconstructor
		*/
		virtual ~Reaction();

		//! Notify
		/*!
			shall notify the event subscriber
			\param - the event this is
		*/
		virtual void Notify(EventPublisher * eventPublisher);

	protected:

	private:
		
};

