#pragma once

#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

//Foundation
#include "SList.h"

//Architecture
#include "RTTI.h"
#include "Datum.h"
#include "Scope.h"

//Reaction
#include "Reaction.h"

//Action
#include "ActionList.h"

//Event
#include "IEventSubscriber.h"
#include "EventMessageAttributed.h"
#include "Event.h"


//AKA a subscriber
class ReactionAttributed : public Reaction
{
	public:
		RTTI_DECLARATIONS(ReactionAttributed, Reaction)

		//! Constructor
		/*!
			a basic constructor
		*/
		ReactionAttributed();

		//! Deconstructor
		/*!
			a virtual deconstructor
		*/
		virtual ~ReactionAttributed();

		//! Notify
		/*!
			shall notify the event subscriber
			\param - the event this is
		*/
		virtual void Notify(EventPublisher * eventPublisher);

		//! SetupAction
		/*!
			\param - the slist of attributes to parse through
		*/
		virtual bool SetupAction(SList< pair<std::string, std::string> > * attributes);
	
	protected:
		std::string mSubtype;

	private:
		
};

//Macro
ActionFactory(ReactionAttributed);

