#pragma once


#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>
#include <stdlib.h>

#include "RTTI.h"

#include "SList.h"

#include "HashMap.h"
#include "Scope.h"
#include "Vector.h"
#include "Attributed.h"
#include "IXmlParseHelper.h"

#include "expat.h"

#include "Factory.h"
#include "WorldState.h"
#include "Entity.h"


using namespace std;

//Forward Declarations
class World;

class Sector : public Attributed
{
	public:
		RTTI_DECLARATIONS(Sector, Attributed)

		//! Constructor
		/*!
			a basic constructor
		*/
		Sector();

		//! Deconstructor
		/*!
			a basic virtual deconstructor
		*/
		virtual ~Sector();
		
		//! NewEntity
		/*!
			returns a pointer to a newly created entity
			\param - the class to create
			\return - a pointer to the newly created entity
		*/
		Entity * NewEntity(std::string entityClassName, std::string instanceName);

		//! NewScope
		/*!
			returns a pointer to a newly created scope
			\param - the name to assign to the scope
			\param - the index to insert the scope name
			\return - a pointer to the newly created scope
		*/
		void NewScope(std::string scopeName, unsigned int index = 0);


		//! SetWorld
		/*!
			sets the world pointer
			\param - the new pointer to the World
		*/
		void SetWorld(World * newWorld);

		//! GetWorld
		/*!
			returns the world pointer
			\return - returns a pointer to the World
		*/
		World * GetWorld();

		//! Process
		/*!
			Processes this sector and all entites inside of it
			\param - a pointer to the current world state
		*/
		void Process(WorldState * currentWorldState);


	protected:

	private:
		World * mWorld;
	

};