#pragma once


#include <string>
#include <sstream>
#include <stdio.h>
#include <utility>

#include "RTTI.h"


#include "expat.h"

#include <stdlib.h>

using namespace std;

#include "Stack.h"

//Forward Declarations
class World;
class Sector;
class Entity;
class Action;
class Scope;

class WorldState
{
	public:
		WorldState();
		~WorldState();
		

		//!  SetTime
		/*!
			Gets the container of sectors that are in this world
			\param - the current time
			\param - the new elapsed time
		*/
		void SetTime(double newTime, float newElapsedTime);
	
		World * mWorld; ///< address of World currently being processed
		Sector * mSector; ///< address of Sector currently being processed
		Entity * mEntity; ///< address of IEntity currently being processed
		Action * mAction; ///< address of Action currently being processed

		//Time
		double mCurrentTime;
		float mElapsedTime;
		
		Stack<Scope*> mActivationStack;

	protected:

	private:
};