#include "Action.h"

RTTI_DEFINITIONS(Action)

Action * Action::NewAction(Scope * scopeAddress, std::string actionClassName, std::string instanceName, unsigned int index, SList< pair<std::string, std::string> > * attributes)
{
	Scope * newOwner = scopeAddress;

	// Need to check if this is a valid type to add an action to...
	assert(newOwner->Is("ActionList") || newOwner->Is("Entity"));

	Action * newAction = Factory<Action>::Create(actionClassName);
	if(attributes){
		bool result = newAction->SetupAction(attributes);
		if(result == false)
			assert(false);
	}


	if(newOwner->Is("Entity")) // Get the entity's action list, if it's an entity
		newOwner = & newOwner->AppendScope("ActionList");

	newOwner->Adopt(newAction, instanceName, index);

	return(newAction);
}

Action * Action::Clone(std::string typeName)
{
	Action * clonedAction = Factory<Action>::Create(typeName);

	return(clonedAction);
}

Action::Action()
{
}

Action::~Action()
{
}

bool Action::LinkActionParameters()
{
	return true;
}

bool Action::SetupAction(SList< pair<std::string, std::string> > * attributes)
{
	return false;
}