#include "ActionCreateAction.h"

RTTI_DEFINITIONS(ActionCreateAction)

ActionCreateAction::ActionCreateAction() : mAddressOfContainerScope(NULL), mUsed(false)
{
	//Need to be aux attributes
	Signature sPrototype;
	sPrototype.mNumElements = 1;
	sPrototype.mName = "sPrototype";
	sPrototype.mInit = NULL;
	sPrototype.mStorage.TYPE_STRING = &mCreatedClassName;
	sPrototype.mType = Datum::TYPE_STRING;
	
	Signature sName;
	sName.mNumElements = 1;
	sName.mName = "sName";
	sName.mInit = NULL;
	sName.mStorage.TYPE_STRING = &mCreatedInstanceName;
	sName.mType = Datum::TYPE_STRING;

	Signature rContainer;
	rContainer.mNumElements = 1;
	rContainer.mName = "rContainer";
	rContainer.mInit = NULL;
	rContainer.mStorage.TYPE_STRING = &mCreatedNameOfContainerScope;
	rContainer.mType = Datum::TYPE_STRING;
	
	Populate();
}

ActionCreateAction::~ActionCreateAction()
{
	mAddressOfContainerScope = NULL;
}

void ActionCreateAction::Process(WorldState * currentWorldState)
{
	if((LinkActionParameters()) && (mUsed == false)){
		NewAction(mAddressOfContainerScope, mCreatedClassName, mCreatedInstanceName, mAddressOfContainerScope->Size());
		mUsed = true;
	}
}

bool ActionCreateAction::LinkActionParameters()
{
	if(mAddressOfContainerScope == NULL){
		if((mCreatedClassName.size() > 0)&&(mCreatedInstanceName.size() > 0)&&(mCreatedNameOfContainerScope.size() > 0)){
			Datum * newOwner =  Search(mCreatedNameOfContainerScope);
			if(newOwner->GetType() == Datum::TYPE_SCOPE){
				mAddressOfContainerScope = newOwner->Get<Datum::ScopeType>();
				return true;
			}
		}
		return false;
	}
	return true;
}

bool ActionCreateAction::SetupAction(SList< pair<std::string, std::string> > * attributes)
{
	for(SList< pair<std::string, std::string> >::SListIterator mySListIterator = attributes->Begin(); mySListIterator != attributes->End(); mySListIterator++){
		if((*mySListIterator).first == "createdActionClass")
			mCreatedClassName = (*mySListIterator).second;
		else if((*mySListIterator).first == "createdActionName")
			mCreatedInstanceName = (*mySListIterator).second;
		else if((*mySListIterator).first == "createdActionOwnerName")
			mCreatedNameOfContainerScope = (*mySListIterator).second;
	}
	if((mCreatedClassName.size() > 0)&&(mCreatedInstanceName.size() > 0)&&(mCreatedNameOfContainerScope.size() > 0))
		return true;
	return false;
}
