#include "ActionDestroyAction.h"

RTTI_DEFINITIONS(ActionDestroyAction)

ActionDestroyAction::ActionDestroyAction() : mIndex(INT_MAX)
{
	Signature rAction;
	rAction.mNumElements = 1;
	rAction.mName = " rAction";
	rAction.mInit = NULL;
	rAction.mStorage.TYPE_STRING = &mNameOfActionToDestroy;
	rAction.mType = Datum::TYPE_STRING;

	Populate();
}

ActionDestroyAction::~ActionDestroyAction()
{
}

void ActionDestroyAction::Process(WorldState * currentWorldState)
{
	unsigned int targetIndex = mIndex;
	if(mIndex == INT_MAX)
		targetIndex = 0;
	if(mNameOfActionToDestroy.size() > 0){
		Datum * newOwner = Search(mNameOfActionToDestroy);
		if((newOwner != NULL) && (newOwner->GetType() == Datum::TYPE_SCOPE) && (newOwner->Size() > 0)){
			Scope * scopePointer =  newOwner->Get<Datum::ScopeType>();
			if(scopePointer->Is("Action")){
				Action * actionPointer = scopePointer->As<Action>(); 
				//REMOVE THEM ALL!
				if(mIndex == INT_MAX){
					actionPointer->GetParent()->RemoveEntry(mNameOfActionToDestroy);
				}
				else{
					actionPointer->GetParent()->RemoveScopeEntry(mNameOfActionToDestroy, targetIndex, true);
					if(actionPointer->Size() == 0) // Don't want an empty scope array
						actionPointer->GetParent()->RemoveEntry(mNameOfActionToDestroy);
				}
			}
		}
	}
}

bool ActionDestroyAction::SetupAction(SList< pair<std::string, std::string> > * attributes)
{
	for(SList< pair<std::string, std::string> >::SListIterator mySListIterator = attributes->Begin(); mySListIterator != attributes->End(); mySListIterator++){
		if((*mySListIterator).first == "destroyedActionName")
			mNameOfActionToDestroy  = (*mySListIterator).second;
		else if((*mySListIterator).first == "destroyedActionIndex"){
			Datum tempStringDatum;
			tempStringDatum.SetType(Datum::TYPE_STRING);
			tempStringDatum.Set((*mySListIterator).second);
			mIndex  = tempStringDatum.GetAs<int>();
		}
	}
	if(mNameOfActionToDestroy.size() > 0)
		return true;
	return false;
}
