#include "ActionPrint.h"

#include <stdio.h>

RTTI_DEFINITIONS(ActionPrint)

ActionPrint::ActionPrint() : mDatumToPrint(NULL), mIndex(0)
{
	//Need to be aux attributes
	Signature sPrototype;
	sPrototype.mNumElements = 1;
	sPrototype.mName = "sPrototype";
	sPrototype.mInit = NULL;
	sPrototype.mStorage.TYPE_STRING = &mNameOfDatumToPrint;
	sPrototype.mType = Datum::TYPE_STRING;
	
	Populate();
}

ActionPrint::~ActionPrint()
{
	mDatumToPrint = NULL;
}

void ActionPrint::Process(WorldState * currentWorldState)
{
	if(LinkActionParameters())
		cout<<"\n"<<mNameOfDatumToPrint<<" : "<<mDatumToPrint->GetAs<std::string>(mIndex)<<"\n";
}



bool ActionPrint::LinkActionParameters()
{
	if(mDatumToPrint == NULL){
		if(mNameOfDatumToPrint.size() > 0){
			mDatumToPrint =  Search(mNameOfDatumToPrint);
			if(mDatumToPrint != NULL)
				return true;
		}
		return false;
	}
	return true;
}

bool ActionPrint::SetupAction(SList< pair<std::string, std::string> > * attributes)
{
	for(SList< pair<std::string, std::string> >::SListIterator mySListIterator = attributes->Begin(); mySListIterator != attributes->End(); mySListIterator++){
		if((*mySListIterator).first == "printedEntry")
			mNameOfDatumToPrint = (*mySListIterator).second;
		else if((*mySListIterator).first == "printedIndex"){
			Datum tempStringDatum;
			tempStringDatum.SetType(Datum::TYPE_STRING);
			tempStringDatum.Set((*mySListIterator).second);
			mIndex = tempStringDatum.GetAs<int>();
		}
	}
	if(mNameOfDatumToPrint.size() > 0)
		return true;
	return false;
}