#include "ActionSetWorldTime.h"

RTTI_DEFINITIONS(ActionSetWorldTime)

ActionSetWorldTime::ActionSetWorldTime()
{
	Signature fTime;
	fTime.mNumElements = 1;
	fTime.mName = "fTime";
	fTime.mInit = NULL;
	fTime.mStorage.TYPE_FLOAT = &mTime;
	fTime.mType = Datum::TYPE_FLOAT;

	Signature fElapsedTime;
	fElapsedTime.mNumElements = 1;
	fElapsedTime.mName = "fElapsedTime";
	fElapsedTime.mInit = NULL;
	fElapsedTime.mStorage.TYPE_FLOAT = &mElaspedTime;
	fElapsedTime.mType = Datum::TYPE_FLOAT;

	Populate();
}

ActionSetWorldTime::~ActionSetWorldTime()
{
}

void ActionSetWorldTime::Process(WorldState * currentWorldState)
{
	currentWorldState->SetTime(mTime, mElaspedTime);
}

bool ActionSetWorldTime::SetupAction(SList< pair<std::string, std::string> > * attributes)
{
	for(SList< pair<std::string, std::string> >::SListIterator mySListIterator = attributes->Begin(); mySListIterator != attributes->End(); mySListIterator++){
		if((*mySListIterator).first == "setTime"){
			Datum tempStringDatum;
			tempStringDatum.SetType(Datum::TYPE_STRING);
			tempStringDatum.Set((*mySListIterator).second);
			mTime  = tempStringDatum.GetAs<float>();
		}
		else if((*mySListIterator).first == "setElapsedTime"){
			Datum tempStringDatum;
			tempStringDatum.SetType(Datum::TYPE_STRING);
			tempStringDatum.Set((*mySListIterator).second);
			mElaspedTime  = tempStringDatum.GetAs<float>();
		}
	}
	return true;
}
