#include "Entity.h"

RTTI_DEFINITIONS(Entity)

Entity::Entity() : mSector(NULL)
{
	ActionList * myActionList = new ActionList();
	Adopt(myActionList, "ActionList", Size());
}

Entity::~Entity()
{
	mSector = NULL;
}


Sector * Entity::GetSector()
{
	return(mSector);
}
void Entity::SetSector(Sector * newSector)
{
	mSector = newSector;
}

Entity * Entity::Clone(std::string typeName)
{
	Entity * clonedEntity = Factory<Entity>::Create(typeName);

	clonedEntity->SetSector(GetSector());

	return(clonedEntity);
}

void Entity::Process(WorldState * currentWorldState)
{
	//Set Entity
	currentWorldState->mEntity = this;

	Scope & actionList = AppendScope("ActionList");
	for(unsigned int i = 0; i < actionList.Size(); i++){
		Datum * currentActionEntry = actionList.GetEntry(i);
		if(currentActionEntry->GetType() == Datum::TYPE_SCOPE){
			for(unsigned int j = 0; j < currentActionEntry->Size(); j++){
				Scope * currentActionScope = currentActionEntry->Get<Datum::ScopeType>(j);
				if(currentActionScope->Is("Action")){
					if(currentActionScope->Is("ReactionAttributed") == false){
						Action * currentAction = currentActionScope->As<Action>();
						
						//Set Action
						currentWorldState->mAction = currentAction;
						
						//Process
						currentAction->Process(currentWorldState);
					}
				}
			}
		}
	}
}