#include "IXmlParseHelper.h"

/**********************************
	SharedData
***********************************/

RTTI_DEFINITIONS(IXmlParseHelper::SharedData)

IXmlParseHelper::SharedData::SharedData() : mNestingDepth(0)
{	
}

IXmlParseHelper::SharedData* IXmlParseHelper::SharedData::Create()
{
	return(this);	
}

void IXmlParseHelper::SharedData::SetXmlParseMaster(XmlParseMaster* newXmlParseMaster)
{
	mXmlParseMaster = newXmlParseMaster;
}

XmlParseMaster* IXmlParseHelper::SharedData::GetXmlParseMaster()
{
	return(mXmlParseMaster);
}

void IXmlParseHelper::SharedData::IncDepth()
{
	mNestingDepth++;
}

void IXmlParseHelper::SharedData::DecDepth()
{
	mNestingDepth--;
}

unsigned int IXmlParseHelper::SharedData::GetDepth()
{
	return(mNestingDepth);
}



/**********************************
	IXmlParseHelper
***********************************/

IXmlParseHelper::IXmlParseHelper()
{
}

IXmlParseHelper::~IXmlParseHelper()
{
	mValidTags.Clear();
}

void IXmlParseHelper::Init()
{
}


bool IXmlParseHelper::StartElementHandler(std::string tagName, SList< pair<std::string, std::string> > attributeValuePairs)
{
	return(false);
}

bool IXmlParseHelper::EndElementHandler(std::string tagName)
{
	return(false);
}

void IXmlParseHelper::CharDataHandler(std::string buffer)
{
}

bool IXmlParseHelper::CheckIfValidTag(std::string tag)
{
	if(mValidTags.Size() > 0){
		for(SList<std::string>::SListIterator tagIterator = mValidTags.Begin(); tagIterator != mValidTags.End(); tagIterator++){
			if(*tagIterator == tag)
				return true;
		}
		//return false;
	}
	return false;//true;
}
