#include "Sector.h"

RTTI_DEFINITIONS(Sector)

Sector::Sector()
{
	AppendScope("EntityList");
}

Sector::~Sector()
{

}

Entity * Sector::NewEntity(std::string entityClassName, std::string instanceName)
{
	Entity * newEntity = Factory<Entity>::Create(entityClassName);
	Scope & entityList = AppendScope("EntityList");

	entityList.Adopt(newEntity, instanceName, Size());

	newEntity->SetSector(this);

	return(newEntity);
}

void Sector::NewScope(std::string scopeName, unsigned int index)
{
	AppendScope(scopeName, index);
}

void Sector::SetWorld(World * newWorld)
{
	mWorld = newWorld;
}

World * Sector::GetWorld()
{
	return(mWorld);
}

void Sector::Process(WorldState * currentWorldState)
{
	//Set Sector
	currentWorldState->mSector = this;

	Scope & entityList = AppendScope("EntityList");
	for(unsigned int i = 0; i < entityList.Size(); i++){
		Datum * currentEntry = entityList.GetEntry(i);
		if(currentEntry->GetType() == Datum::TYPE_SCOPE)
		{
			Scope * currentScopeEntry = currentEntry->Get<Datum::ScopeType>();	
			if(currentScopeEntry->Is("Entity"))
			{
				Entity * currentEntity = currentScopeEntry->As<Entity>();
				currentEntity->Process(currentWorldState);
			}
		}
	}
}