#include "World.h"

RTTI_DEFINITIONS(World)

World::World()
{
	AppendScope("SectorList",0);
	mWorldState.mWorld = this; 
}

World::~World()
{
	RemoveEntry("SectorList");
}

Sector * World::AppendSector(std::string sectorName, std::string fileName, Sector * parentSector)
{
	Sector * newSector = new Sector();
	newSector->SetWorld(this);

	//Get the list of sectors
	Scope & sectorList = AppendScope("SectorList");

	sectorList.Adopt(newSector, sectorName , Size());

	return(newSector);
}

Scope * World::GetSectors()
{
	//Get the list of sectors
	Scope & sectorList = AppendScope("SectorList");
	return(&sectorList);
}

int World::GetSignature()
{
	return(0);
}

void World::Process()
{
	//Update Events
	mEventQueue.Publish(mWorldState.mCurrentTime);

	//Get the list of sectors
	Scope & sectorList = AppendScope("SectorList");
	for(unsigned int i = 0; i < sectorList.Size(); i++)
	{
		Scope & temporaryScopeReference = sectorList.AppendScope(sectorList.GetMemberName(i));	
		if(temporaryScopeReference.Is("Sector"))
		{
			Sector* currentSector = temporaryScopeReference.As<Sector>(); 
			currentSector->Process(&mWorldState);
		}
	}
}

WorldState & World::GetWorldState()
{
	return mWorldState;
}

EventQueue & World::GetEventQueue()
{
	return mEventQueue;
}