#include "XmlParseHelperConcrete.h"

/**********************************
	SharedData
***********************************/
RTTI_DEFINITIONS(XmlParseHelperConcrete::SharedDataConcrete)


/**********************************
	XmlParseHelperConcrete
***********************************/

XmlParseHelperConcrete::XmlParseHelperConcrete(XmlParseMaster* newParseMaster)
{
	mMaster = newParseMaster;
	if(mMaster)
		mMaster->AddHelper(this);
}

XmlParseHelperConcrete::~XmlParseHelperConcrete()
{
	if(mMaster){
		if(mMaster->GetIsClone() == false){
			mMaster->RemoveHelper(this);
			mMaster = NULL;
		}
	}
}

XmlParseHelperConcrete* XmlParseHelperConcrete::Create(XmlParseMaster* referencedParseMaster)
{
	XmlParseHelperConcrete* newHelper = new XmlParseHelperConcrete(referencedParseMaster);
	return(newHelper);
}

bool XmlParseHelperConcrete::StartElementHandler(std::string tagName, SList< pair<std::string, std::string> > attributeValuePairs)
{
	XmlParseHelperConcrete::SharedDataConcrete* sharedData = reinterpret_cast<XmlParseHelperConcrete::SharedDataConcrete*>(mMaster->GetSharedData());

	if(sharedData->Is("XmlParseHelperConcrete::SharedDataConcrete")){
	
		sharedData->isSelfTerminating.Push(true);
		sharedData->xmlResults.append("<");
		sharedData->xmlResults.append(tagName);

		for(SList< pair<std::string, std::string> >::SListIterator mSLI = attributeValuePairs.Begin(); mSLI != attributeValuePairs.End(); mSLI++)
		{
			sharedData->xmlResults.append((*mSLI ).first);
			sharedData->xmlResults.append("=\"");
			sharedData->xmlResults.append((*mSLI ).second);
			sharedData->xmlResults.append("\"");
		}
		sharedData->xmlResults.append(">");
		return true;
	}
	return false;
}

bool XmlParseHelperConcrete::EndElementHandler(std::string tagName)
{
	XmlParseHelperConcrete::SharedDataConcrete* sharedData = reinterpret_cast<XmlParseHelperConcrete::SharedDataConcrete*>(mMaster->GetSharedData());
	if(sharedData->Is("XmlParseHelperConcrete::SharedDataConcrete"))
	{
		if(sharedData->isSelfTerminating.Top() == false)
		{
			sharedData->xmlResults.append("</");
			sharedData->xmlResults.append(tagName);
		}
		else
		{
			sharedData->xmlResults.erase(sharedData->xmlResults.length()-1, 1);
			sharedData->xmlResults.append("/");
		}

		sharedData->xmlResults.append(">");
		sharedData->isSelfTerminating.Pop();
		return true;
	}
	return false;
}


void XmlParseHelperConcrete::CharDataHandler(std::string buffer)
{
	XmlParseHelperConcrete::SharedDataConcrete* sharedData = reinterpret_cast<XmlParseHelperConcrete::SharedDataConcrete*>(mMaster->GetSharedData());
	sharedData->isSelfTerminating.Top() = false;
	//sharedData->xmlResults.append(">");
}


