#include "XmlParseHelperEntity.h"

/**********************************
	XmlParseHelperEntity
***********************************/

XmlParseHelperEntity::XmlParseHelperEntity(XmlParseMaster* newParseMaster)
{
	mMaster = newParseMaster;
	if(mMaster)
		mMaster->AddHelper(this);

	//Add Valid Tags
	mValidTags.PushBack("entity");
	mValidTags.PushBack("sector");
}

XmlParseHelperEntity::~XmlParseHelperEntity()
{
	if(mMaster){
		if(mMaster->GetIsClone() == false){
			mMaster->RemoveHelper(this);
			mMaster = NULL;
		}
	}
}

XmlParseHelperEntity* XmlParseHelperEntity::Create(XmlParseMaster* referencedParseMaster)
{
	XmlParseHelperEntity* newHelper = new XmlParseHelperEntity(referencedParseMaster);
	return(newHelper);
}

bool XmlParseHelperEntity::StartElementHandler(std::string tagName, SList< pair<std::string, std::string> > attributeValuePairs)
{
	if(CheckIfValidTag(tagName) == false)
		return false;

	XmlParseHelperScope::SharedDataScope* sharedData = reinterpret_cast<XmlParseHelperScope::SharedDataScope*>(mMaster->GetSharedData());
	if(sharedData->Is("XmlParseHelperScope::SharedDataScope")){
		if(tagName != "root"){
			World * myWorld = sharedData->GetGlobalScope().As<World>();


			SList< pair<std::string, std::string> >::SListIterator mySListIterator = attributeValuePairs.Begin();

			std::string instanceName;
			std::string className;
			

			if(tagName == "entity"){
				for(;mySListIterator != attributeValuePairs.End(); mySListIterator++){
					if((*mySListIterator).first == "instanceName")
						instanceName = (*mySListIterator).second;
					else if((*mySListIterator).first == "class")
						className = (*mySListIterator).second;
				}
				//New Entity
				Entity * newEntity = (sharedData->mCurrentScope->As<Sector>())->NewEntity(className, instanceName);
				sharedData->mCurrentScope = newEntity;
				return true;
			}
			else if(tagName == "sector"){
				for(;mySListIterator != attributeValuePairs.End(); mySListIterator++){
					if((*mySListIterator).first == "name")
						instanceName = (*mySListIterator).second;
				}
				//New Sector
				sharedData->mCurrentScope = myWorld->AppendSector(instanceName);
				return true;
			}
		}
	}
	return false;
}

bool XmlParseHelperEntity::EndElementHandler(std::string tagName)
{
	if(CheckIfValidTag(tagName) == false)
		return false;

	XmlParseHelperScope::SharedDataScope* sharedData = reinterpret_cast<XmlParseHelperScope::SharedDataScope*>(mMaster->GetSharedData());
	if(sharedData->Is("XmlParseHelperScope::SharedDataScope")){
		//if((tagName == "sector") || (tagName == "entity")){
			if(sharedData->mCurrentScope->GetParent() != NULL)
				sharedData->mCurrentScope = sharedData->mCurrentScope->GetParent();
		//}
		return true;
	}
	return false;
}


void XmlParseHelperEntity::CharDataHandler(std::string buffer)
{
	XmlParseHelperScope::SharedDataScope* sharedData = reinterpret_cast<XmlParseHelperScope::SharedDataScope*>(mMaster->GetSharedData());
	if(sharedData->Is("XmlParseHelperEntity::SharedDataScope")){
	}
}

