#ifndef UNIVERSE_H
#define UNIVERSE_H

//#include "SList.h"

#include <stdio.h>											
#include <stdarg.h>

//Actions
#include "ActionCreateAction.h"
#include "ActionDestroyAction.h"
#include "ActionPrint.h"
#include "ActionListWhile.h"
#include "ActionEvent.h"
#include "ActionSetWorldTime.h"

//Reactions
#include "ReactionAttributed.h"


class Universe
{
public:
	Universe();
	~Universe();
	
	//Function prototypes.
	void Process(double timeNow, float timeChange);


protected:
	
private:
	//Factories
	ActionCreateActionFactory mActionCreateActionFactory;
	
	ActionDestroyActionFactory mActionDestroyActionFactory;

	ActionPrintFactory mActionPrintFactory;

	ActionListWhileFactory mActionListWhileFactory;

	ActionEventFactory mActionEventFactory;

	ReactionAttributedFactory mReactionAttributedFactory;

	ActionSetWorldTimeFactory mActionSetWorldTime;

};



#endif