
/* 01_vertex_program.c - OpenGL-based very simple vertex program example
   using Cg program from Chapter 2 of "The Cg Tutorial" (Addison-Wesley,
   ISBN 0321194969). */

/* Requires the OpenGL Utility Toolkit (GLUT) and Cg runtime (version
   1.0 or higher). */

#include "stdafx.h"

#define GLUT_DISABLE_ATEXIT_HACK

#include <stdio.h>    //! for printf and NULL
#include <stdlib.h>   //! for exit								
#include <stdarg.h>

#include "glut.h"

#include "Universe.h"
#include "SList.h"

//! Forward declared GLUT callbacks registered by main.

Universe myUniverse;
void mydisplay()		//! display the scene
{
	myUniverse.Process(10.0f, 10.0f);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glutSwapBuffers();
}


int main(int argc, char **argv)
{
	

	glutInitWindowSize(400, 400);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInit(&argc, argv);

	glutCreateWindow("FieaGameEngine");
	glutDisplayFunc(mydisplay);


	glClearColor(0.0, 0.0, 1.0, 0.0);  //! Blue background

	glutMainLoop();
	return 0;
}