#ifndef __FACTORYTEST_H
#define __FACTORYTEST_H

#include <cxxtest/TestSuite.h>
#include "Factory.h"
#include "string.h"
#include "Attributed.h"
#include "Scope.h"


class TestBaseClass : public RTTI
{
	public:
		RTTI_DECLARATIONS(TestBaseClass, RTTI)
		int mValue;
};
RTTI_DEFINITIONS(TestBaseClass)

class TestDerClass : public TestBaseClass
{
	public:
		RTTI_DECLARATIONS(TestDerClass, TestBaseClass)
		int mValue2;
};
RTTI_DEFINITIONS(TestDerClass)


//Factory
ConcreteFactory(TestBaseClass, TestDerClass)

/*!
*	A simple test suite: Just inherit CxxTest::TestSuite and write tests!
*/
class FactoryUnitTest : public CxxTest::TestSuite
{
public:

	/*!
	*	Tests the Factory function
	*/
	void testFactory()
	{
		TestDerClassFactory myFactory;
		TS_ASSERT_EQUALS(Factory<TestBaseClass>::Find("TestDerClass")->GetClassName(), "TestDerClass");

		TestBaseClass * myTestClass = Factory<TestBaseClass>::Create("TestDerClass");

		TS_ASSERT_EQUALS(myTestClass->Is("TestBaseClass"), true);
		TS_ASSERT_EQUALS(myTestClass->Is("TestDerClass"), true);
		

		delete myTestClass;
	}
};

#endif // __FACTORYTEST_H